datatype Tree<T> = Leaf(data: T) | Node(left: Tree<T>, right: Tree<T>)

function treeSize<T>(t: Tree<T>): nat {
  match t 
  case Leaf(_) => 1
  case Node(left, right) => treeSize<T>(left) + treeSize<T>(right) + 1
}

function treeSum(t: Tree<int>): int {
  match t
  case Leaf(data) => data
  case Node(left, right) => treeSum(left) + treeSum(right)
}

method Main() {
  var t:= Node(Leaf(1), Node(Leaf(7), (Node(Leaf(5), Leaf(8)))));
  assert(treeSize<int>(t) >= 0);
  print("Tree size: ");
  print(treeSize<int>(t));
  print("\nTree sum: ");
  print(treeSum(t));
  print("\n");
}